/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.tntleague.command

import de.steamwar.command.SWCommand
import de.steamwar.command.TypeValidator
import de.steamwar.tntleague.colorByTeam
import de.steamwar.tntleague.config.TNTLeagueConfig
import de.steamwar.tntleague.game.TNTLeagueGame
import de.steamwar.tntleague.message
import net.md_5.bungee.api.chat.ClickEvent
import org.bukkit.entity.Player

object InviteCommand: SWCommand("invite") {

    @Register
    fun invitePlayer(@Validator("isLeader") sender: Player, target: Player) {
        if (TNTLeagueConfig.isEvent()) return
        if (TNTLeagueGame.state != TNTLeagueGame.GameState.LOBBY) return
        if (TNTLeagueGame.getTeam(target) != null) return

        val team = TNTLeagueGame.getTeam(sender)!!
        team.invites.add(target)

        message
            .send("INVITED", target, message.parse("INVITED_HOVER", target, team.name),
                ClickEvent(ClickEvent.Action.RUN_COMMAND, "/accept " + sender.name), sender.name.colorByTeam(team), team.name)

        message.send("INVITED_PLAYER", sender, target.name)
    }

    @Validator("isLeader", local = false)
    fun isLeader(): TypeValidator<Player> {
        return TypeValidator<Player> { _, player, _ -> TNTLeagueGame.getTeam(player)?.leader == player}
    }
}
